#!/usr/bin/env python3
# -*- coding: utf-8 -*-
import numpy as np
F = np.matrix('1.0  1  0  0;  0  1  1  0; 0  0  1  1').transpose()
S = np.matrix('4.0 -1  0  0; -1  4 -1  0; 0 -1  4 -1; 0  0 -1  4')

def sp(u,v,S): # scalar product (u,v) = u' * S * v
    return u.transpose().dot(S.dot(v))[0,0]

def gs(F,S): # Gramm Schmidt orthorormalization E = gs(F,S)
    n = F.shape[1]
    E = F.copy()
    for i in range(0,n):
        if (i>0):
            for j in range(0,i):
                alpha = sp(E[:,i],E[:,j],S)
                E[:,i] -= alpha * E[:,j]
        E[:,i] *= 1/np.sqrt(sp(E[:,i],E[:,i],S))
        
    return E

E = gs(F,S)
print(E)

